"""
    Time Series API For Digital Portals

    Time series data, end-of-day or intraday, tick-by-tick or subsampled. Additional vendor-specific endpoints provide a modified interface for seamless integration with the ChartIQ chart library.  This API is focused on high-performance applications that are  * serving millions of end-users, * accessible by client browsers via the internet, * integrated into complex infrastructures such as existing frontend frameworks or authentication services.  This API has been designed for direct use by client web applications and feature extreme low latency: The average response time across all endpoints is 30 ms whereas 99% of all requests are answered in close to under 300ms.  See the [Real-Time Quotes API for Digital Portals](https://developer.factset.com/api-catalog/real-time-quotes-api) for access to detailed price information.   # noqa: E501

    The version of the OpenAPI document: 3.0.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.RealTimeTimeSeries.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.RealTimeTimeSeries.exceptions import ApiAttributeError


def lazy_import():
    from fds.sdk.RealTimeTimeSeries.model.post_prices_time_series_intraday_list_request_data_range import PostPricesTimeSeriesIntradayListRequestDataRange
    from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_eod_list_request_data_identifier import PostVendorChartIQTimeSeriesEodListRequestDataIdentifier
    from fds.sdk.RealTimeTimeSeries.model.post_vendor_chart_iq_time_series_intraday_subsample_get_request_data_adjustments import PostVendorChartIQTimeSeriesIntradaySubsampleGetRequestDataAdjustments
    globals()['PostPricesTimeSeriesIntradayListRequestDataRange'] = PostPricesTimeSeriesIntradayListRequestDataRange
    globals()['PostVendorChartIQTimeSeriesEodListRequestDataIdentifier'] = PostVendorChartIQTimeSeriesEodListRequestDataIdentifier
    globals()['PostVendorChartIQTimeSeriesIntradaySubsampleGetRequestDataAdjustments'] = PostVendorChartIQTimeSeriesIntradaySubsampleGetRequestDataAdjustments


class PostPricesTimeSeriesIntradayListRequestData(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'TRADE': "trade",
            'BID': "bid",
            'ASK': "ask",
            'YIELD': "yield",


        },
        ('quality',): {
            'RLT': "RLT",
            'DLY': "DLY",
            'BST': "BST",


        },
        ('apply_tick_corrections',): {
            'NONE': "none",
            'ALL': "all",


        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'identifier': (PostVendorChartIQTimeSeriesEodListRequestDataIdentifier,),  # noqa: E501
            'range': (PostPricesTimeSeriesIntradayListRequestDataRange,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'quality': (str,),  # noqa: E501
            'newest_first': (bool,),  # noqa: E501
            'apply_tick_corrections': (str,),  # noqa: E501
            'include_volume_only_ticks': (bool,),  # noqa: E501
            'adjustments': (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequestDataAdjustments,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'identifier': 'identifier',  # noqa: E501
        'range': 'range',  # noqa: E501
        'type': 'type',  # noqa: E501
        'quality': 'quality',  # noqa: E501
        'newest_first': 'newestFirst',  # noqa: E501
        'apply_tick_corrections': 'applyTickCorrections',  # noqa: E501
        'include_volume_only_ticks': 'includeVolumeOnlyTicks',  # noqa: E501
        'adjustments': 'adjustments',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, identifier, range, *args, **kwargs):  # noqa: E501
        """PostPricesTimeSeriesIntradayListRequestData - a model defined in OpenAPI

        Args:
            identifier (PostVendorChartIQTimeSeriesEodListRequestDataIdentifier):
            range (PostPricesTimeSeriesIntradayListRequestDataRange):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            type (str): Type of the price as configured for the customer.. [optional] if omitted the server will use the default value of "trade"  # noqa: E501
            quality (str): Quality of the price.. [optional] if omitted the server will use the default value of "DLY"  # noqa: E501
            newest_first (bool): Deliver the chronological last part of the requested data first.. [optional] if omitted the server will use the default value of False  # noqa: E501
            apply_tick_corrections (str): This attribute represents the choice whether to apply insert, update, and delete corrections for individual ticks sent by the exchange or devised by FactSet Digital Solutions GmbH.   If the exchange or FactSet Digital Solutions GmbH decides to correct data, a correction instruction tick is sent shortly (usually on the same trading day) after dissemination of the corresponding original tick (if any). The correction instruction is then applied, yielding a corrected view. For \"insert\" corrections, there is no original tick, and the corrected view contains the inserted tick. For \"update\" corrections, the corrected view contains the updated original tick. For \"delete\" corrections, the original tick is removed from the corrected view.. [optional] if omitted the server will use the default value of "none"  # noqa: E501
            include_volume_only_ticks (bool): Include ticks that contain a volume without a price.. [optional] if omitted the server will use the default value of False  # noqa: E501
            adjustments (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequestDataAdjustments): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.identifier = identifier
        self.range = range
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, identifier, range, *args, **kwargs):  # noqa: E501
        """PostPricesTimeSeriesIntradayListRequestData - a model defined in OpenAPI

        Args:
            identifier (PostVendorChartIQTimeSeriesEodListRequestDataIdentifier):
            range (PostPricesTimeSeriesIntradayListRequestDataRange):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            type (str): Type of the price as configured for the customer.. [optional] if omitted the server will use the default value of "trade"  # noqa: E501
            quality (str): Quality of the price.. [optional] if omitted the server will use the default value of "DLY"  # noqa: E501
            newest_first (bool): Deliver the chronological last part of the requested data first.. [optional] if omitted the server will use the default value of False  # noqa: E501
            apply_tick_corrections (str): This attribute represents the choice whether to apply insert, update, and delete corrections for individual ticks sent by the exchange or devised by FactSet Digital Solutions GmbH.   If the exchange or FactSet Digital Solutions GmbH decides to correct data, a correction instruction tick is sent shortly (usually on the same trading day) after dissemination of the corresponding original tick (if any). The correction instruction is then applied, yielding a corrected view. For \"insert\" corrections, there is no original tick, and the corrected view contains the inserted tick. For \"update\" corrections, the corrected view contains the updated original tick. For \"delete\" corrections, the original tick is removed from the corrected view.. [optional] if omitted the server will use the default value of "none"  # noqa: E501
            include_volume_only_ticks (bool): Include ticks that contain a volume without a price.. [optional] if omitted the server will use the default value of False  # noqa: E501
            adjustments (PostVendorChartIQTimeSeriesIntradaySubsampleGetRequestDataAdjustments): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.identifier = identifier
        self.range = range
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
